<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class AgSimplesFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
   
    public function getFactoryLocal() {
        $sql = "SELECT NMTIPOLOCALCLI, NRTIPOLOCALCLI
                  FROM FCM_TIPOLOCALCLI";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryLocalAt($id, $filters = null) {
        $query = "SELECT FCM_LOCALCLI.NRLOCALCLIENTE, 
            FCM_LOCALCLI.NMLOCALCLIENTE, FCM_LOCALCLI.CDCLIENTE, 
            FCM_LOCALCLI.NRTIPOLOCALCLI, FCM_LOCALCLI.NRLOCALCLIENTEPAI,
            FCM_LOCALCLI.NRCHECKLISTPADR, FCM_LOCALCLI.NRSETOR, 
            FCM_LOCALCLI.DSICONELOCAL, FCM_LOCALCLI.DSQRCODE,
            FCM_LOCALCLI.IDATIVO, FCM_LOCALCLI.NRORG, FCM_LOCALCLI.DTINCLUSAO,
            FCM_LOCALCLI.CDOPERINCLUSAO, FCM_LOCALCLI.NRORGINCLUSAO,
            FCM_LOCALCLI.DTULTATU, FCM_LOCALCLI.CDOPERULTATU,
            FCM_LOCALCLI.NRORGULTATU, FCM_LOCALCLI.NRGRUPOLOCAL,
            FCM_TIPOLOCALCLI.NMTIPOLOCALCLI
            FROM FCM_LOCALCLI
            INNER JOIN FCM_TIPOLOCALCLI ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
            WHERE FCM_LOCALCLI.NRLOCALCLIENTEPAI = {$id}";
            
            $sqlSide = $this->connection->prepare($query);
            $sqlSide->execute();
            return $sqlSide->fetchAll();
    }
    
    public function getFactoryChildrenLocal($param) {
        $sql = "SELECT NMLOCALCLIENTE, NRLOCALCLIENTE
                 FROM FCM_LOCALCLI
                WHERE NRTIPOLOCALCLI = :NRLOCALCLIENTEPAI";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute($param);
        return $std->fetchAll();
    }
    
    public function getFactoryAgSimplesPage($param) {
        $sql = "SELECT NMLOCALCLIENTE, NRLOCALCLIENTE
                 FROM FCM_LOCALCLI
                WHERE NRLOCALCLIENTE = :NRLOCALCLIENTE";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute($param);
        return $std->fetchAll();
    }
}
?>