<?php
namespace FM\Service;

use FM\Factory\FuncoesFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class FuncoesService {
    
    protected $FuncoesFactory;
    protected $environment;
    protected $newCode;
    
    public function __construct (FuncoesFactory $FuncoesFactory, Environment $Environment, NewCode $newCode) {
        $this->FuncoesFactory  = $FuncoesFactory;
        $this->environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function getPositionsService($params){
        $validParam = '';
        
        if($params['positionSearch'] != '' && $params['positionSearch'] != null ) {
            $validParam = " WHERE UPPER(FCM_PERFILACESSO.NMPERFILACESSO) LIKE UPPER('%".$params['positionSearch']."%')";
        }
        
        $operadores = $this->FuncoesFactory->getPositionsFactory($validParam);
        return $operadores;
    }
    
    public function positionsListService(){
        $operadores = $this->FuncoesFactory->positionsListFactory();
        return $operadores;
    }
    
    public function createPositionService($nmperfilacesso, $idpermisssusuario, $idpermissstarefas, $idpermissslocais, $idpermissschecklist, $idpermisssrelatorios, $idpermisssgraficos, $idpermisssvistoria, $idpermissscalend, $iddirecionaqrcode,  $idtipodashboard) {
        
        $nrperfilacesso = $this->newCode->getCodeByTableName('FCM_PERFILACESSO', $this->environment->getNrOrg(), 1, 10, true);  
        
        $params = array (
            'NRPERFILACESSO' => $nrperfilacesso,
            'NMPERFILACESSO' => $nmperfilacesso,
            'IDPERMISSSUSUARIO' => $idpermisssusuario,
            'IDPERMISSSTAREFAS' => $idpermissstarefas,
            'IDPERMISSSLOCAIS' => $idpermissslocais,
            'IDPERMISSSCHECKLIST' => $idpermissschecklist,
            'IDPERMISSSRELATORIOS' => $idpermisssrelatorios,
            'IDPERMISSSGRAFICOS' => $idpermisssgraficos,
            'IDATIVO' => 'S',
            'IDPERMISSSVISTORIA' => $idpermisssvistoria,
            'IDPERMISSSCALEND' => $idpermissscalend,
            'IDDIRECIONAQRCODE' => $iddirecionaqrcode,
            'IDTIPODASHBOARD' => $idtipodashboard,
        );
        try {
            $this->FuncoesFactory->createPositionFactory($params);
            $response = "Inserido com sucesso";
        } catch (\Exception $e) {
            $response = $e->getMessage();
        }
        return $response;
    }
    
    public function getPositionInfoService($id){
        $operadores = $this->FuncoesFactory->getPositionInfoFactory($id);
        return $operadores;
    }
    
    public function updatePositionService($nrperfilacesso, $nmperfilacesso, $idpermisssusuario, $idpermissstarefas, $idpermissslocais, $idpermissschecklist, $idpermisssrelatorios, $idpermisssgraficos, $idpermisssvistoria, $idpermissscalend, $iddirecionaqrcode, $idtipodashboard) {
        
        $params = array (
            'NRPERFILACESSO' => $nrperfilacesso,
            'NMPERFILACESSO' => $nmperfilacesso,
            'IDPERMISSSUSUARIO' => $idpermisssusuario,
            'IDPERMISSSTAREFAS' => $idpermissstarefas,
            'IDPERMISSSLOCAIS' => $idpermissslocais,
            'IDPERMISSSCHECKLIST' => $idpermissschecklist,
            'IDPERMISSSRELATORIOS' => $idpermisssrelatorios,
            'IDPERMISSSGRAFICOS' => $idpermisssgraficos,
            'IDPERMISSSVISTORIA' => $idpermisssvistoria,
            'IDPERMISSSCALEND' => $idpermissscalend,
            'IDDIRECIONAQRCODE' => $iddirecionaqrcode,
            'IDTIPODASHBOARD' => $idtipodashboard
        );
        
         
        try {
            $this->FuncoesFactory->updatePositionFactory($params);
            $response = "Editado com sucesso";
        } catch (\Exception $e) {
            $response = $e->getMessage();
        }
        return $response;
    }
    
    public function deletePositionsService($params){
        $cont = 0;
        
        foreach($params as $positionX) {
            foreach($positionX as $position){
                $validParam = array (
                    'NRPERFILACESSO' => $position
                );
                $validaRelacFunc = $this->FuncoesFactory->validPositionsInRelacFuncFactory($validParam);
                $valida = $validaRelacFunc[0]['VALIDA'];
                if($valida == 0){
                    $this->FuncoesFactory->deletePositionsFactory($validParam);
                } else $cont++;            
            }
        }
        
        return $cont;
    }
    
    // Busca qual as permissões para o usuário logado
    public function getPositionPermiss($nrfuncionario){
        $permissions = $this->FuncoesFactory->getPermissions($nrfuncionario);
        $permissions[0]['token'] = md5(strval($nrfuncionario));
        
        return $permissions;
    }
}
?>