<?php

namespace FM\Service;

use FM\Factory\RelInsumosEquipFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class RelInsumosEquipService {

    protected $RelInsumosEquipFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct (EntityManager $entityManager, RelInsumosEquipFactory $RelInsumosEquipFactory, Environment $Environment, NewCode $newCode) {
        $this->RelInsumosEquipFactory = $RelInsumosEquipFactory;
        $this->connection = $entityManager->getConnection();
        $this->environment = $Environment;
        $this->newCode = $newCode;
    }
    
    public function relacaoInsumos($params) {
        $this->connection->beginTransaction();
        
        try {
            foreach($params["dados"] as $categoria){
                foreach($categoria["LISTA"] as $tipoManutencao){
                    foreach($tipoManutencao["LISTA"] as $insumo){
                        if($insumo["BANCO"]){
                            $this->RelInsumosEquipFactory->updateRelacaoInsumos(array(
                                "QTMEDIDA" => $insumo["QTMEDIDA"],
                                "NREQUIPAMENTO" => $params["NREQUIPAMENTO"],
                                "NRINSUMO" => $insumo["NRINSUMO"],
                                "NRTIPOMANUTENCAO" => $tipoManutencao["NRTIPOMANUTENCAO"],
                                "NRCATEGORIAMANUT" => $categoria["NRCATEGORIAMANUT"]
                            ));
                        } else {
                            $this->RelInsumosEquipFactory->insertRelacaoInsumos(array(
                                "NRRELINSUMOSEQUIP" => $this->newCode->getCodeByTableName("FCM_RELINSUMOSEQUIP", $this->environment->getNrOrg(), 1, 10, true),
                                "NREQUIPAMENTO" => $params["NREQUIPAMENTO"],
                                "NRINSUMO" => $params["NREQUIPAMENTO"],
                                "NRTIPOMANUTENCAO" => $tipoManutencao["NRTIPOMANUTENCAO"],
                                "QTMEDIDA" => $insumo["QTMEDIDA"],
                                "NRORG" => $this->environment->getNrOrg(),
                                "NRCATEGORIAMANUT" => $categoria["NRCATEGORIAMANUT"]
                            ));
                        }
                    }
                }
            }
            
            
            $this->connection->commit();
            $response = "OK";
        } catch(\Exception $e) {
            $this->connection->rollback();
            $response = ($e->getMessage());
        }
        return $response;
    }
}

?>